package com.caimei.module.base.entity.po;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * buyer_product_price
 * @author
 */
@Data
public class BuyerProductPrice implements Serializable {
    private Long id;

    /**
     * 商品的ID
     */
    private Long productId;

    /**
     * 买家用户ID
     */
    private Long userId;

    /**
     * 税率
     */
    private BigDecimal taxRate;

    /**
     * 单个应付供应商成本
     */
    private BigDecimal singleShopFee;

    /**
     * 折后单价
     */
    private BigDecimal discountPrice;

    /**
     * 创建人
     */
    private Long createBy;

    /**
     * 创建时间
     */
    private Date createDate;

    /**
     * 最后更新人
     */
    private Long updateBy;

    /**
     * 最后更新时间
     */
    private Date updateDate;

    /**
     * 确认标识 0否 1已确认（折后单价小于成本价或供应商价时使用，用于红色提示和同意按钮）
     */
    private String confirmFlag;

    /**
     * 删除标记 0正常 1禁用
     */
    private String delFlag;

    private static final long serialVersionUID = 1L;
}
