package com.caimei.module.search.service.impl;

import com.caimei.module.search.dao.SearchMapper;
import com.caimei.module.search.entity.vo.CmMallOrderVo;
import com.caimei.module.search.entity.vo.CmMallOrganizeProductsVo;
import com.caimei.module.search.entity.vo.CmMallProductLadderPriceVo;
import com.caimei.module.search.entity.vo.CmMallProductSearchHistoryVo;
import com.caimei.module.search.service.SearchService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2020/2/27
 */
@Service
public class SearchServiceImpl implements SearchService {
    @Resource
    private SearchMapper searchMapper;
    @Override
    public List<CmMallOrganizeProductsVo> searchProduct(Integer organizeID, String searchWord) {
        List<CmMallOrganizeProductsVo> productsList = searchMapper.searchProduct(organizeID, searchWord);
        return productsList;
    }

    @Override
    public void deleteProductRecord(Integer organizeID, String openID) {
        searchMapper.deleteProductRecord(organizeID, openID);
    }

    @Override
    public void saveProductRecord(Integer organizeID, String searchWord, String openID) {
        CmMallProductSearchHistoryVo productSearchHistory = new CmMallProductSearchHistoryVo();
        productSearchHistory.setOpenID(openID);
        productSearchHistory.setDelFlag("0");
        productSearchHistory.setOrganizeID(organizeID);
        productSearchHistory.setSearchDate(new Date());
        productSearchHistory.setSearchWord(searchWord);
        searchMapper.saveProductRecord(productSearchHistory);
    }

    @Override
    public List<CmMallProductSearchHistoryVo> findProductRecord(Integer organizeID, String openID) {
        return searchMapper.findProductRecord(organizeID, openID);
    }

    @Override
    public CmMallProductLadderPriceVo findLadderPrice(Long id) {
        return searchMapper.findLadderPrice(id);
    }

    @Override
    public void deleteRecord(Integer organizeID, String openID) {
        searchMapper.deleteRecord(organizeID, openID);
    }

    @Override
    public CmMallProductSearchHistoryVo findAllProductRecord(Integer organizeID, String searchWord, String openID) {
        return searchMapper.findAllProductRecord(organizeID, openID, searchWord);
    }

    @Override
    public void updateProductRecord(Integer organizeID, String searchWord, String openID) {
        CmMallProductSearchHistoryVo productSearchHistory = new CmMallProductSearchHistoryVo();
        productSearchHistory.setOpenID(openID);
        productSearchHistory.setOrganizeID(organizeID);
        productSearchHistory.setSearchDate(new Date());
        productSearchHistory.setSearchWord(searchWord);
        searchMapper.updateProductRecord(productSearchHistory);
    }

    @Override
    public CmMallProductSearchHistoryVo findAllOrderRecord(Integer organizeID, String searchWord, String openID) {
        return searchMapper.findAllOrderRecord(organizeID, openID, searchWord);
    }

    @Override
    public void saveOrderRecord(Integer organizeID, String searchWord, String openID) {
        CmMallProductSearchHistoryVo orderSearchHistory = new CmMallProductSearchHistoryVo();
        orderSearchHistory.setOpenID(openID);
        orderSearchHistory.setDelFlag("0");
        orderSearchHistory.setOrganizeID(organizeID);
        orderSearchHistory.setSearchDate(new Date());
        orderSearchHistory.setSearchWord(searchWord);
        searchMapper.saveOrderRecord(orderSearchHistory);
    }

    @Override
    public void deleteOrderRecord(Integer organizeID, String openID) {
        searchMapper.deleteOrderRecord(organizeID, openID);
    }

    @Override
    public void updateOrderRecord(Integer organizeID, String searchWord, String openID) {
        CmMallProductSearchHistoryVo orderSearchHistory = new CmMallProductSearchHistoryVo();
        orderSearchHistory.setOpenID(openID);
        orderSearchHistory.setOrganizeID(organizeID);
        orderSearchHistory.setSearchDate(new Date());
        orderSearchHistory.setSearchWord(searchWord);
        searchMapper.updateOrderRecord(orderSearchHistory);
    }

    @Override
    public List<CmMallOrderVo> searchOrder(Integer organizeID, String searchWord, Long userID) {
        List<CmMallOrderVo> orderList = searchMapper.searchOrder(organizeID, searchWord, userID);
        return orderList;
    }

    @Override
    public List<CmMallProductSearchHistoryVo> findOrderRecord(Integer organizeID, String openID) {
        return searchMapper.findOrderRecord(organizeID, openID);
    }

    @Override
    public void deleteSearchHistory(Integer organizeID, String openID) {
        searchMapper.deleteSearchHistory(organizeID, openID);
    }
}
